<?php
// vim: foldmethod=marker
/**
 *  Ethna_Plugin_Generator.php
 *
 *  @author     Masaki Fujimoto <fujimoto@php.net>
 *  @license    http://www.opensource.org/licenses/bsd-license.php The BSD License
 *  @package    Ethna
 *  @version    $Id: Ethna_Plugin_Generator.php,v 1.1 2006/08/22 15:36:13 fujimoto Exp $
 */

// {{{ Ethna_Plugin_Generator
/**
 *  ȥץ饰
 *
 *  @author     Masaki Fujimoto <fujimoto@php.net>
 *  @access     public
 *  @package    Ethna
 */
class Ethna_Plugin_Generator
{
    /**
     *  ȥե˥ޥŬѤƥե
     *
     *  ethna饤֥Υǥ쥯ȥ깽¤ѹƤʤȤ
     *  ȤʤäƤ
     *
     *  @access private
     *  @param  string  $skel       ȥե
     *  @param  string  $entity     ե̾
     *  @param  array   $macro      ִޥ
     *  @return bool    true:ｪλ false:顼
     */
    function _generateFile($skel, $entity, $macro)
    {
        $base = null;

        if (file_exists($entity)) {
            printf("file [%s] already exists -> skip\n", $entity);
            return true;
        }
        $c =& Ethna_Controller::getInstance();
        if (is_object($c)) {
            $base = $c->getBasedir();
            if (file_exists("$base/skel/$skel") == false) {
                $base = null;
            }
        }
        if (is_null($base)) {
            $base = dirname(dirname(dirname(__FILE__)));
        }

        $rfp = fopen("$base/skel/$skel", "r");
        if ($rfp == null) {
            return false;
        }
        $wfp = fopen($entity, "w");
        if ($wfp == null) {
            fclose($rfp);
            return false;
        }

        for (;;) {
            $s = fread($rfp, 4096);
            if (strlen($s) == 0) {
                break;
            }

            foreach ($macro as $k => $v) {
                $s = preg_replace("/{\\\$$k}/", $v, $s);
            }
            fwrite($wfp, $s);
        }

        fclose($wfp);
        fclose($rfp);

        $st = stat("$base/skel/$skel");
        if (chmod($entity, $st[2]) == false) {
            return false;
        }

        printf("file generated [%s -> %s]\n", $skel, $entity);

        return true;
    }

    /**
     *  桼Υޥꤹ(~/.ethna)
     *
     *  @access private
     */
    function _getUserMacro()
    {
        if (isset($_SERVER['USERPROFILE']) && is_dir($_SERVER['USERPROFILE'])) {
            $home = $_SERVER['USERPROFILE'];
        } else {
            $home = $_SERVER['HOME'];
        }

        if (is_file("$home/.ethna") == false) {
            return array();
        }

        $user_macro = parse_ini_file("$home/.ethna");
        return $user_macro;
    }
}
// }}}
?>
