<?php
/**
 *	Flare_Account.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.app_object.php,v 1.2 2006/03/07 16:23:18 fujimoto Exp $
 */

define('FLARE_ACCOUNT_TYPE_CACHE', 1);
define('FLARE_ACCOUNT_TYPE_CREDIT', 2);
define('FLARE_ACCOUNT_TYPE_BANK', 3);

/**
 *	Flare_AccountManager
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_AccountManager extends Ethna_AppManager
{
    var $account_type_list = array(
        FLARE_ACCOUNT_TYPE_CACHE => array('name' => '󤭤'),
        FLARE_ACCOUNT_TYPE_CREDIT => array('name' => ''),
        FLARE_ACCOUNT_TYPE_BANK => array('name' => ''),
    );

    function getIdFromHash($user_hash, $account_hash)
    {
        $r = $this->db->sqlquery('get_hash', $user_hash, $account_hash);
        $row = $r->fetchRow(DB_FETCHMODE_ASSOC);
        return array($row['user_id'], $row['account_id']);
    }
}

/**
 *	Flare_Account
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Account extends Ethna_AppObject
{
    /**
     *  ץѥƥɽ̾
     *
     *  @access public
     */
    function getName($key)
    {
        if ($key == 'type') {
            $am =& $this->backend->getManager('account');
            return $am->getAttrName('account_type', $this->get($key));
        }
        return $this->get($key);
    }

    function add()
    {
        $this->set('ctime', strftime('%Y/%m/%d %H:%M:%S'));
        $this->set('hash', Ethna_Util::getRandom());

        return parent::add();
    }

    function getMail()
    {
        $user =& $this->backend->getObject('user', 'user_id', $this->get('user_id'));

        $mail = sprintf('flare+%s_%s@nx.eth.jp', substr($this->get('hash'), 0, 8), substr($user->get('hash'), 0, 8));
        return $mail;
    }
}
?>
