<?php
/**
 *	Flare_Tag.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.app_object.php,v 1.2 2006/03/07 16:23:18 fujimoto Exp $
 */

/**
 *	Flare_TagManager
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_TagManager extends Ethna_AppManager
{
    function add($tag, $journal_id)
    {
        $tag_list = $this->_parseTag($tag);

        foreach ($tag_list as $tag_name) {
            $tag = $this->backend->getObject('tag');
            $tag->set('name', $tag_name);
            $tag->add();

            $tag =& $this->backend->getObject('tag', 'name', $tag_name);
            $journal_tag =& $this->backend->getObject('journal_tag');
            $journal_tag->set('journal_id', $journal_id);
            $journal_tag->set('tag_id', $tag->getId());
            $journal_tag->add();
        }
    }

    function getTagList($user_id = null)
    {
        if ($user_id) {
            $r = $this->db->sqlquery('get_user_tag_list', $user_id);
            if (Ethna::isError($r)) {
                return $r;
            }
        } else {
            $r = $this->db->sqlquery('get_tag_list');
            if (Ethna::isError($r)) {
                return $r;
            }
        }

        $tag_list = array();
        while ($row = $r->fetchRow(DB_FETCHMODE_ASSOC)) {
            $tag_list[] = $row;
        }

        return $tag_list;
    }

    function _parseTag($tag)
    {
        $tag = mb_convert_kana($tag, "s");
        $list = preg_split('/\s+/', $tag, -1, PREG_SPLIT_NO_EMPTY);
        return $list;
    }
}

/**
 *	Flare_Tag
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Tag extends Ethna_AppObject
{
    /**
     *  ץѥƥɽ̾
     *
     *  @access public
     */
    function getName($key)
    {
        return $this->get($key);
    }

    function add()
    {
        $this->set('ctime', strftime('%Y/%m/%d %H:%M:%S'));

        return parent::add();
    }
}
?>
