<?php
/**
 *	Flare_UrlHandler.php
 *
 *	@author		Masaki Fujimoto
 *	@package    Flare
 *	@version    $Id: app.url_handler.php,v 1.1 2006/08/23 13:22:31 fujimoto Exp $
 */

/**
 *	URLϥɥ饯饹
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_UrlHandler extends Ethna_UrlHandler
{
	/**	@var	array	ޥåԥ */
	var	$action_map = array(
        'user'	=> array(
            'user_signup' => array(
                'path'			=> 'signup',
                'path_regexp'	=> false,
                'path_ext'		=> false,
                'option'		=> array(),
            ),
            'user_signin' => array(
                'path'			=> 'signin',
                'path_regexp'	=> false,
                'path_ext'		=> false,
                'option'		=> array(),
            ),
            'user_signout' => array(
                'path'			=> 'signout',
                'path_regexp'	=> false,
                'path_ext'		=> false,
                'option'		=> array(),
            ),
			'user_config' => array(
                'path'			=> 'config',
                'path_regexp'	=> false,
                'path_ext'		=> false,
                'option'		=> array(),
			),
        ),
		'account' => array(
			'account' => array(
                'path'			=> '',
                'path_regexp'	=> false,
                'path_ext'		=> false,
                'option'		=> array(),
			),
		),
		'index' => array(
			'index' => array(
                'path'			=> '',
                'path_regexp'	=> false,
                'path_ext'		=> false,
                'option'		=> array(),
			),
		),
        'journal' => array(
            'journal_month' => array(
                'path'			=> 'month',
                'path_regexp'	=> '|^month/([0-9]{4}\-[0-9]{1,2})|',
                'path_ext'		=> array(
                    'month' => array(),
                ),
                'option'		=> array(),
            ),
            'journal_tag_user' => array(
                'path'			=> 'tag/user',
                'path_regexp'	=> '|^tag/user/(.*)$|',
                'path_ext'		=> array(
                    'tag' => array(),
                ),
                'option'		=> array(),
            ),
            'journal_tag' => array(
                'path'			=> 'tag',
                'path_regexp'	=> '|^tag/(.*)$|',
                'path_ext'		=> array(
                    'tag' => array(),
                ),
                'option'		=> array(),
            ),
        ),
    );

	/**
	 *	Flare_UrlHandler饹Υ󥹥󥹤
	 *
	 *	@access	public
	 */
	function &getInstance($class_name = null)
	{
        $instance =& parent::getInstance(__CLASS__);
        return $instance;
	}

	// {{{ ȥꥯ
	/**
	 *	ꥯ(userȥ)
	 *
	 *	@access	private
	 */
    /*
	function _normalizeRequest_User($http_vars)
	{
        return $http_vars;
	}
     */
	// }}}

	// {{{ ȥѥ
	/**
	 *	ѥ(userȥ)
	 *
	 *	@access	private
	 */
	function _getPath_User($action, $param)
	{
		return array("/user", array());
	}
	// }}}

	// {{{ ȥѥ
	/**
	 *	ѥ(accountȥ)
	 *
	 *	@access	private
	 */
	function _getPath_Account($action, $param)
	{
		return array("/account", array());
	}
	// }}}

	// {{{ ȥѥ
	/**
	 *	ѥ(journalȥ)
	 *
	 *	@access	private
	 */
	function _getPath_Journal($action, $param)
	{
		return array("/journal", $param);
	}
	// }}}

	// {{{ ȥѥ
	/**
	 *	ѥ(indexȥ)
	 *
	 *	@access	private
	 */
	function _getPath_Index($action, $param)
	{
		return array("/", array());
	}
	// }}}

	// {{{ ե륿
	// }}}
}

// vim: foldmethod=marker tabstop=4 shiftwidth=4 autoindent
?>
