--
--	flare.sql
--
--	$Id$
--
DROP DATABASE flare;
CREATE DATABASE flare;
USE flare;

--
--	user
--
CREATE TABLE user (
	user_id		INT4 NOT NULL AUTO_INCREMENT,
	alias		VARCHAR(255) NOT NULL UNIQUE,
	mail		VARCHAR(255) NOT NULL UNIQUE,
	password	VARCHAR(255) NOT NULL,
	name		VARCHAR(255) NOT NULL,
	type		INT1 NOT NULL,
	state		INT1 NOT NULL,
	hash		VARCHAR(255) NOT NULL,
	ctime		DATETIME,
	mtime		TIMESTAMP,
	PRIMARY KEY(user_id),
	INDEX(mail),
	INDEX(hash)
) TYPE=MyISAM;

--
--	account
--
CREATE TABLE account (
	id			INT4 NOT NULL AUTO_INCREMENT,
	user_id		INT4 NOT NULL,
	type		INT1 NOT NULL,
	name		VARCHAR(255) NOT NULL,
	hash		VARCHAR(255) NOT NULL,
	ctime		DATETIME NOT NULL,
	mtime		TIMESTAMP NOT NULL,
	PRIMARY KEY(id),
	INDEX(user_id, type)
) TYPE=MyISAM;

--
--	journal
--
CREATE TABLE journal (
	id			INT4 NOT NULL AUTO_INCREMENT,
	user_id		INT4 NOT NULL,
	account_id	INT4 NOT NULL,
	name		TEXT NOT NULL,
	inout		INT4 NOT NULL,
	ctime		DATETIME NOT NULL,
	mtime		TIMESTAMP NOT NULL,
	PRIMARY KEY(id)
) TYPE=MyISAM;

--
--	tag
--
CREATE TABLE tag (
	id			INT4 NOT NULL AUTO_INCREMENT,
	name		VARCHAR(255) NOT NULL UNIQUE,
	ctime		DATETIME NOT NULL,
	mtime		TIMESTAMP NOT NULL,
	PRIMARY KEY(id)
) TYPE=MyISAM;

--
--	journal_tag
--
CREATE TABLE journal_tag (
	journal_id	INT4 NOT NULL,
	tag_id		INT4 NOT NULL,
	PRIMARY KEY(journal_id, tag_id)
) TYPE=MyISAM;
